﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace TcpClientConsole
{
    class Program
    {
        static void Main(string[] args)
        {
            IPEndPoint server = new IPEndPoint(IPAddress.Parse(Properties.Settings.Default.remoteIp), Properties.Settings.Default.remotePort);

            Console.WriteLine("TCP Client Parameters");
            Console.WriteLine("Remote IP:\t{0}", Properties.Settings.Default.remoteIp);
            Console.WriteLine("Remote Port:\t{0}", Properties.Settings.Default.remotePort);

            bool run = true;

            while (run)
            {
                Console.WriteLine();
                Console.Write("Send: ");
                string content = Console.ReadLine();

                if (content == "Q" | content == "q")
                    run = false;
                else
                    Send(server, content);
            }
            
        }

        static void Send(IPEndPoint server, String message)
        {
            try
            {
                // Create a TcpClient. 
                // Note, for this client to work you need to have a TcpServer  
                // connected to the same address as specified by the server, port 
                // combination.
                //Int32 port = 10000;
                TcpClient client = new TcpClient(AddressFamily.InterNetwork);
                //TcpClient client = new TcpClient(server);
             

                // Translate the passed message into ASCII and store it as a Byte array.
                Byte[] data = System.Text.Encoding.ASCII.GetBytes(message);

                // Get a client stream for reading and writing. 
                //  Stream stream = client.GetStream();
                client.Connect(server);

                NetworkStream stream = client.GetStream();

                // Send the message to the connected TcpServer. 
                stream.Write(data, 0, data.Length);

                //Console.WriteLine("Sent: {0}", message);

                // Receive the TcpServer.response. 

                // Buffer to store the response bytes.
                //data = new Byte[256];

                // String to store the response ASCII representation.
                //String responseData = String.Empty;

                // Read the first batch of the TcpServer response bytes.
                //Int32 bytes = stream.Read(data, 0, data.Length);
                //responseData = System.Text.Encoding.ASCII.GetString(data, 0, bytes);
                //Console.WriteLine("Received: {0}", responseData);

                // Close everything.
                stream.Close();
                client.Close();
            }
            catch (ArgumentNullException e)
            {
                Console.WriteLine("ArgumentNullException: {0}", e);
            }
            catch (SocketException e)
            {
                Console.WriteLine("SocketException: {0}", e);
            }

            //Console.WriteLine("\n Press Enter to continue...");
            //Console.Read();
        }
    }
}
